import RTIcap.*;

/*
*/
public class DeclarationManager 
{
    ObjectClassNaming objNaming ;


    /**
    */
    public 
    DeclarationManager(ObjectClassNaming _objNaming)
    { objNaming = _objNaming;}

    /**
    * 5.2
    */
    public
    void publishObjectClass(short theClass, short[] attributeList,
                            FederateAmb _fedHandle, short _fedId   )
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {

        ObjectRecord objRecord = (ObjectRecord) objNaming.getObjectRecord(theClass);
        if(objRecord==null) throw new RTIcap.ObjectClassNotDefined();

        AttributeWatcher attWatcher ; 
        boolean except = false;
        for(int i=0;i<attributeList.length;i++)
        {
           attWatcher = (AttributeWatcher) objRecord.getAttributeWatcher(attributeList[i]);
           if(attWatcher!=null) attWatcher.register_publisher(_fedHandle,_fedId);
           else except = true;

        }// end of for

        if(except) throw new RTIcap.AttributeNotDefined();

    }// end of publishObjectClass()

    /**
    * 5.3
    */
    public
    void unpublishObjectClass(short theClass, FederateAmb _fedHandle, 
                              short _fedId )
         throws RTIcap.ObjectClassNotDefined, RTIcap.FederateOwnsAttributes, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {

        ObjectRecord objRecord = (ObjectRecord) objNaming.getObjectRecord(theClass);
        if(objRecord==null) throw new RTIcap.ObjectClassNotDefined();

        objRecord.deregisterAll_publisher(_fedId);

    } 

    /**
    * 5.2
    */
    public
    void publishObjectClass(short theClass, short[] attributeList)
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {

    }// end of publishObjectClass()

    /**
    * 5.3
    */
    public
    void unpublishObjectClass(short theClass)
         throws RTIcap.ObjectClassNotDefined, RTIcap.FederateOwnsAttributes, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    } 

    /**
    * 5.4
    */
    public
    void publishInteractionClass(short theInteraction)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    * 5.5
    */
    public
    void unpublishInteractionClass(short theInteraction)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    * 5.6
    *
    *  Get ObjectRecord
    *  Find AttributeWatcher Object
    *  Subscribe yourself to this queue.
    *
    */
    public
    void subscribeObjectClassAttribute(short theClass, short[] attributeList,
                                       FederateAmb _fedHandle, short _fedId   )
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {

        ObjectRecord objRecord = (ObjectRecord) objNaming.getObjectRecord(theClass);
        if(objRecord==null) throw new RTIcap.ObjectClassNotDefined();

        AttributeWatcher attWatcher ; 
        boolean except = false;

        for(int i=0;i<attributeList.length;i++)
        {
           attWatcher = (AttributeWatcher) objRecord.getAttributeWatcher(attributeList[i]);
           if(attWatcher!=null) attWatcher.subscribe(_fedHandle,_fedId);
           else except = true;

        }// end of for

        if(except) throw new RTIcap.AttributeNotDefined();

    }// end of subscribeObjectClassAttribute()

    /**
    * 5.7
    */
    public
    void unsubscribeObjectClassAttribute(short theClass, short[] attributeList,
                                       FederateAmb _fedHandle, short _fedId   )
         throws RTIcap.ObjectClassNotDefined, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {

        ObjectRecord objRecord = (ObjectRecord) objNaming.getObjectRecord(theClass);
        if(objRecord==null) throw new RTIcap.ObjectClassNotDefined();

        AttributeWatcher attWatcher ; 
        boolean except = false;
        for(int i=0;i<attributeList.length;i++)
        {
           attWatcher = (AttributeWatcher) objRecord.getAttributeWatcher(attributeList[i]);
           if(attWatcher!=null) attWatcher.unsubscribe(_fedId);
           else except = true;

        }// end of for

    }// end of unsubscribeObjectClassAttribute()

    /**
    * 5.6
    */
    public
    void subscribeObjectClassAttribute1(short theClass, short[] attributeList)
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    * 5.6
    */
    public
    void subscribeObjectClassAttribute2(short theClass, short theAttribute, 
                int theRegion)
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.RegionNotKnown, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    * 5.7
    */
    public
    void unsubscribeObjectClassAttribute1(short theClass)
         throws RTIcap.ObjectClassNotDefined, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    * 5.7
    */
    public
    void unsubscribeObjectClassAttribute2(short theClass, int theRegion)
         throws RTIcap.ObjectClassNotDefined, RTIcap.RegionNotKnown, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    * 5.8
    */
    public
    void subscribeInteractionClass1(short theClass)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    * 5.8
    */
    public
    void subscribeInteractionClass2(short theClass, int theRegion)
         throws RTIcap.InteractionClassNotDefined, RTIcap.RegionNotKnown, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    * 5.9
    */
    public
    void unsubscribeInteractionClass1(short theClass)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    * 5.9
    */
    public
    void unsubscribeInteractionClass2(short theClass, int theRegion)
         throws RTIcap.InteractionClassNotDefined, RTIcap.RegionNotKnown, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }


}// end of DeclarationManager

